package com.muyu.rule.common.domain;

import java.util.*;

class Person {
    private String name;
    private int age;

    public Person(String name, int age) {
        this.name = name;
        this.age = age;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Person person = (Person) o;
        return age == person.age &&
                Objects.equals(name, person.name);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, age);
    }

    @Override
    public String toString() {
        return "Person{" +
                "name='" + name + '\'' +
                ", age=" + age +
                '}';
    }



    public static void main(String[] args) {
        Person[] people = new Person[]{
                new Person("Alice", 30),
                new Person("Alice", 30),
                new Person("Bob", 25),
                new Person("Alice", 30),
                new Person("Charlie", 35)
        };

        // 使用 HashSet 去重
        Set<Person> uniquePeople = new HashSet<>(Arrays.asList(people));

        // 将 Set 转换回数组
        Person[] uniqueArray = uniquePeople.toArray(new Person[0]);

        // 输出结果
        System.out.println(Arrays.toString(uniqueArray));
    }


}
