package com.muyu.rule.server;

import com.muyu.rule.common.domain.DataValue;
import com.muyu.rule.server.basic.BasicEngine;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @Author：张承志
 * @Package：com.muyu.rule.server
 * @Project：cloud-etl-rule
 * @name：Main
 * @Date：2024/8/29 15:57
 */
public class Main {

 static  Map<String , BasicEngine<DataValue>> engineMap = new ConcurrentHashMap<>();

 static Map<String,BasicEngine<DataValue[]>> engineRowMap = new ConcurrentHashMap<>();

    static {
        try {
            Class<?> aClass = Class.forName("com.muyu.rule.server.basic.engine.value.ENGINE_VALUE_VFD1000_V1");
            Class<?> aClass2 = Class.forName("com.muyu.rule.server.basic.engine.value.ENGINE_VALUE_VFD1000_V2");
            Class<?> aClass3 = Class.forName("com.muyu.rule.server.basic.engine.row.ENGINE_ROW_HANG_R1");
            try {
                engineMap.put("ENGINE_VALUE_VFD1000_V1", (BasicEngine<DataValue>) aClass.newInstance());
                engineMap.put("ENGINE_VALUE_VFD1000_V2", (BasicEngine<DataValue>) aClass2.newInstance());
                engineRowMap.put("ENGINE_ROW_HANG_R1",(BasicEngine<DataValue[]>) aClass3.newInstance());
            } catch (InstantiationException e) {
                throw new RuntimeException(e);
            } catch (IllegalAccessException e) {
                throw new RuntimeException(e);
            }
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }

    }

    public static void main(String[] args) {

        DataValue[] dataValues = new DataValue[]{
                new DataValue("name","String",null,"张三"),
                new DataValue("name","String",null,"李四"),
                new DataValue("name","String",null,"王五"),
                new DataValue("name","String",null,"张三")
        };

        BasicEngine<DataValue[]> engineRowHangR1 = engineRowMap.get("ENGINE_ROW_HANG_R1");

        engineRowHangR1.set(dataValues);
        engineRowHangR1.execution();


        DataValue dataValue = DataValue.builder()
                .type("String")
                .label("姓名")
                .key("name")
                .value(null)
                .build();

        BasicEngine<DataValue> engineValue = engineMap.get("ENGINE_VALUE_VFD1000_V1");

        engineValue.set(dataValue);

        engineValue.execution();

    }















}


