 package com.muyu.rule.server.engine;


import com.muyu.rule.server.annotation.EngineParam;
import com.muyu.rule.server.pool.container.EngineContainer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.time.LocalDate;
import java.time.Period;
import java.util.Date;
public class Engine_2024_8_23_2347 {


    private static final Logger log = LoggerFactory.getLogger(Engine_2024_8_23_2347.class);

    public String execute( @EngineParam(name = "idcard") String idcard) {

        String msg = "";
        System.out.println();
        try {
            // 提取年份
            String yearStr = idcard.substring(6, 10);
            Integer year = Integer.parseInt(yearStr);

            // 获取当前年份
            LocalDate currentDate = LocalDate.now();
          //  Integer currentYear = currentDate.getYear();

            // 计算年龄
            Period age = Period.between(LocalDate.of(year, 1, 1), currentDate);
            msg = "这个身份证的年龄是: " + age.getYears();

            // 判断性别
            String genderStr = idcard.substring(16, 17);
            Integer gender = Integer.parseInt(genderStr);
            if (gender % 2 == 0) {
                msg += ", 这个身份证是女生";
            } else {
                msg += ", 这个身份证是男生";
            }

            // 获取规则引擎数量
            Integer sumEngine = EngineContainer.getSumEngine();
            log.info("项目中规则引擎数量为: {}", sumEngine);

            // 可选：获取 User 对象并打印信息
            // User user = Springutils.getBean(User.class);
            // log.info("{} --- {}", user.getName(), user.getAge());

            return msg;
        } catch (Exception e) {
            log.error("处理身份证号码时发生错误: {}", e.getMessage(), e);
            return "处理身份证号码时发生错误: " + e.getMessage();
        }
    }
}
