package com.muyu.rule.server.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.muyu.rule.common.domain.DataValue;
import com.muyu.rule.common.domain.RuleEngineVersion;

import java.util.List;

/**
 * @Author：张承志
 * @Package：com.muyu.rule.server.service
 * @Project：cloud-etl-rule
 * @name：RuleEngineService
 * @Date：2024/8/25 14:16
 */
public interface RuleEngineVersionService extends IService<RuleEngineVersion> {

    /**
     * 通过id查询规则引擎和对应的规则引擎版本
     * @param id
     * @return
     */
    List<RuleEngineVersion> selectRuleEngineVersion(Long id);


    void activate(Long id);

    void disable(Long id);



    /**
     *
     * @param versionClazz 具体代码
     * @param className 类的名
     */

    void Upload(String versionClazz,String className);

    /**
     * 从OSS服务器读取文件的接口
     * @param className 类名
     * @return
     */
    Object readByOss(String className);

    void HotLoadClass(String className, String versionClazz);

    void testValue(String versionClazz, DataValue dataValue);
}
